#include <iostream>
#define endl '\n'
using namespace std;

const int MAX = 10000;

bool used[MAX + 5];
bool e[MAX + 5];

void eratosthenes()
{
    e[1] = true;
    for (int i = 2; i * i <= MAX; ++ i)
    {
        if (!e[i])
        {
            for (int j = i * i; j <= MAX; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    eratosthenes();

    long long n;
    int m;
    cin >> n >> m;

    long long cnt = n;
    for (int i = 0; i < m; ++ i)
    {
        int a;
        cin >> a;
        int x = 1;
        for (int j = 1; j <= a; ++ j)
        {
            if (a % j == 0 and !e[j])
            {
                if (used[j])
                {
                    x = cnt + 1;
                    break;
                }
                x *= j;
                used[j] = true;
            }
        }
        cnt = cnt - (cnt / x);
    }
    cout << cnt << endl;

    return 0;
}
