#include <iostream>
#include <vector>
using namespace std;

long long n, m, a[32], answer;
vector <int> t;

long long gcd (long long a, long long b) {
    if (a == 0) {return b;}
    return gcd (b%a, a);
}

long long nok (long long a, long long b) {
    return a*b/gcd(a, b);
}

void solve (int idx, vector <int> v) {
    if (idx >= m) {
        if (v.size() == 0) {return;}
        long long noki=v[0];
        for (int i=0; i < v.size(); i++) {
            noki = nok (noki, v[i]);
        }
        if (v.size() % 2 == 0) {
            answer = answer - (n / noki);
        }
        else {
            answer = answer + (n / noki);
        }
        return;
    }
    v.push_back(a[idx]);
    solve (idx+1, v);
    v.pop_back();
    solve (idx+1, v);
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n >> m;

for (int i=0; i < m; i++) {
    cin >> a[i];
}

sort (a, a + m);

solve (0, t);

cout << n - answer << endl;

return 0;
}