#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int MAX = 10000;

int a[32], b[32];
bool used[MAX + 5];
bool e[MAX + 5];

void eratosthenes()
{
    e[1] = true;
    for (int i = 2; i * i <= MAX; ++ i)
    {
        if (!e[i])
        {
            for (int j = i * i; j <= MAX; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    eratosthenes();

    long long n;
    int m;
    cin >> n >> m;

    for (int i = 0; i < m; ++ i)
    {
        cin >> a[i];
    }

    sort(a, a + m);

    int s = 0;
    for (int i = 0; i < m; ++ i)
    {
        bool flag = true;
        for (int j = 0; j < i; ++ j)
        {
            if (a[i] % a[j] == 0) flag = false;
        }
        if (flag)
        {
            b[s] = a[i];
            s++;
        }
    }

    long long cnt = n;
    for (int i = 0; i < s; ++ i)
    {
        long long x = -1;
        for (int j = 1; j <= b[i]; ++ j)
        {
            if (b[i] % j == 0 and !e[j])
            {
                if (!used[j])
                {
                    if (x == -1) x = 1;
                    x *= j;
                    used[j] = true;
                }
            }
        }
        if (x != -1) cnt = cnt - (cnt / x);
    }

    cout << cnt << endl;

    return 0;
}
