#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAX = 10000;

int a[32];
bool e[MAX + 5];

void eratosthenes()
{
    e[1] = true;
    for (int i = 2; i * i <= MAX; ++ i)
    {
        if (!e[i])
        {
            for (int j = i * i; j <= MAX; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    eratosthenes();

    long long n;
    int m;
    cin >> n >> m;

    for (int i = 0; i < m; ++ i)
    {
        cin >> a[i];
    }

    long long cnt = 0;
    for (int mask = 1; mask < (1 << m); ++ mask)
    {
        vector<int> total(MAX + 5, 0);
        int br = 0;
        for (int i = 0; i < m; ++ i)
        {
            if (mask & (1 << i))
            {
                br++;
                int aa = a[i];
                for (int j = 2; j <= a[i]; ++ j)
                {
                    int br0 = 0;
                    while (aa % j == 0)
                    {
                        aa /= j;
                        br0++;
                    }
                    total[j] = max(total[j], br0);
                }
            }
        }
        long long cnt1 = n;
        for (int j = 1; j <= MAX; ++ j)
        {
            for (int k = 1; k <= total[j]; ++ k)
            {
                cnt1 /= j;
            }
        }
        if (br % 2 == 1) cnt += cnt1;
        else cnt -= cnt1;
    }

    cout << n - cnt << endl;

    return 0;
}
