#include<iostream>
#include<algorithm>
#include<vector>

#define endl '\n'

using namespace std;

const int MAXN=1e4+3,MAXM=25;
long long nums[MAXM];
bool used[MAXN];
vector<long long> divs[MAXN];

bool check(int num){
    for(long long i=2;i<=num;++i){
        if(num%i==0 and used[i]){
            return true;
        }
    }
    return false;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n;
    int m;
    cin>>n>>m;
    for(int i=0;i<m;++i){
        cin>>nums[i];
    }

    long long res=n;
    for(int i=0;i<m;++i){
        if(check(nums[i])){
            nums[i]=-1;
            continue;
        }
        res-=(n/nums[i]);
        for(int i2=i-1;i2>=0;--i2){
            if(nums[i2]!=-1){
                long long curr=nums[i]*nums[i2]/__gcd(nums[i],nums[i2]);
                res+=(n/curr);
                if(nums[i2]%nums[i]==0){
                    nums[i2]=-1;
                }
            }
        }
        used[nums[i]]=true;
    }
    cout<<res<<endl;
return 0;
}
