#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN=2e3+3;
long long dp[MAXN][MAXN];
/// dp[i][diff]-removed i sticks from the first lane
/// diff-distance between the first and second lane

int slow_sol(int a, int b, int c, int d){
    int res=0;
    for(int newa=a;newa<=b;++newa){
        for(int newb=newa;newb<=b;++newb){
            for(int newc=newb+1;newc<=c;++newc){
                int newd=d-c+b-a+newc+newa-newb;
                if(newd>=newc and newd>=d){
                    ++res;
                }
            }
        }
    }
    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int a,b,c,d;
    cin>>a>>b>>c>>d;

    int n=b-a+1,limit=c-b-1;
    dp[0][limit]=1;
    for(int i=1;i<n;++i){
        for(int diff=c;diff>=0;--diff){
            dp[i][diff]+=dp[i-1][diff];
            dp[i][diff+1]+=dp[i-1][diff];
            if(diff>0){
                dp[i][diff-1]+=dp[i-1][diff];
            }
        }
    }

    long long res=1;
    for(int i=0;i<n;++i){
        for(int i2=0;i2<c;++i2){
            //cout<<i<<" "<<i2<<": "<<dp[i][i2]<<endl;
            res+=dp[i][i2];
        }
    }
    cout<<res<<endl;
return 0;
}
